{
 http://community.bistudio.com/wiki?title=ArmA:_Weapons&redirect=no
 RPG7V PG7VR
 JAVELIN JAVELIN
}
type
  tItem		= Record
    n	: String[31];
    case t: Byte of
      0:	(s_val: String[31]);
      1:	(f_val: Single);
      2:	(i_val: LongInt);
      9:	(p_val: Pointer; foffs: LongInt);
  end;

  pItem	= ^tItem;

  tClass	= Record
    c	: Byte;
    i	: Array[0..128] of pItem;
  end;

  pClass = ^tClass;

var
  ft	: Text;
  fb	: File;

const
  nline	: Integer = 0;


function str_compressor(var s: String): Byte;
var n: Byte; onstr: Boolean;
begin
  while (length(s) > 0) and (s[1] in [' ', #9]) do delete(s, 1, 1);
  while (length(s) > 0) and (s[Length(s)] in [' ', #9, ';']) do dec(s[0]);

  if copy(s, 1, 6) = 'class ' then begin
    str_compressor := 9; exit;
  end;

  if pos('.', s) = 0 then str_compressor := 2 else str_compressor := 1;

  n := 1; onstr := False;
  while n <= Length(s) do if onstr then begin
    if s[n] = '"' then begin
      onstr := False; delete(s, n, 1);
    end else inc(n);
  end else begin
    if s[n] = '"' then begin
      str_compressor := 0;
      onstr := True;  delete(s, n, 1);
    end else
    if s[n] in [' ', #9] then delete(s, n, 1) else inc(n);
  end;
end;


procedure getclass(const Cl: pClass);
var
  s	: String;
  WaitS	: Boolean;
  typ,
  k	: Byte;
  s2i	: Integer;

begin
  WaitS := False; Cl^.c := 0;
  for k := Low(Cl^.i) to High(Cl^.i) do Cl^.i[k] := Nil;
  while not eof(ft) do begin
    if Cl^.i[Cl^.c] = Nil then New(Cl^.i[Cl^.c]);
    readln(ft, s); inc(nline); typ := str_compressor(s);
    writeln(nline: 2, '[', typ,']: ', s);
    if s = '}' then exit;
    if WaitS then begin
      if s <> '{' then begin WriteLn('"{" except at line ', nline); halt(1) end;
      WaitS := False;
      getclass(Cl^.i[Cl^.c - 1]^.p_val);
    end else With Cl^.i[Cl^.c]^ do begin
      t := typ;
      if t = 9 then begin
        WaitS := True;
	n := copy(s, 7, 255);
	GetMem(p_val, sizeof(tClass));
      end else begin


        k := pos('=', s); if k = 0 then begin
	  WriteLn('Syntax error at line ', nline); halt(2);
	end;
	n := copy(s, 1, k - 1);
	case typ of
	  0: begin
	    s_val := copy(s, k + 1, 255);
	  end;
	 
	  1: begin
            val(copy(s, k + 1, 255), f_val, s2i);
	    if s2i <> 0 then begin
	      WriteLn('Float point convert error at ', nline, ', ', s2i); Halt(4);
	    end;
	  end;

	  2: begin
	    val(copy(s, k + 1, 255), i_val, s2i);
	    if s2i <> 0 then begin
	      WriteLn('Integer convert error at ', nline, ', ', s2i); Halt(3);
	    end;
	  end;
	end;


      end;
      inc(Cl^.c);
    end;
  end;
end;


procedure putoffs(o, v: LongInt);
var t: LongInt;
begin
  t := filepos(fb); seek(fb, o); blockwrite(fb, v, 4); seek(fb, t);
end;


procedure putstr(s: String);
const b: Byte = 0;
begin
  blockwrite(fb, s[1], length(s));
  blockwrite(fb, b, 1);
end;


var
  MainClass	: tClass;
  long		: LongInt;


procedure putclass(const Cl: pClass);
var k, b, nitems: Byte; tmp: LongInt;
begin
  b := 0;	blockwrite(fb, b, 1);
  b := Cl^.c;	blockwrite(fb, b, 1); nitems := b;
  for k := 0 to nitems - 1 do with Cl^.i[k]^ do case t of
    0: begin
      b := 1;	blockwrite(fb, b, 1);
      b := 0;	blockwrite(fb, b, 1);
      putstr(n); putstr(s_val);
    end;

    1: begin
      b := 1;	blockwrite(fb, b, 1);
      b := 1;	blockwrite(fb, b, 1);
      putstr(n); blockwrite(fb, f_val, 4);
    end;

    2: begin
      b := 1;	blockwrite(fb, b, 1);
      b := 2;	blockwrite(fb, b, 1);
      putstr(n); blockwrite(fb, i_val, 4);
    end;

    9: begin
      b := 0;	blockwrite(fb, b, 1);
      putstr(n); foffs := filepos(fb); tmp := $22222222; blockwrite(fb, tmp, 4);
    end;
  end;

  tmp := FilePos(fb); blockwrite(fb, tmp, 4);
  for k := 0 to nitems - 1 do with Cl^.i[k]^ do if t = 9 then begin putoffs(foffs, filepos(fb)); putclass(p_val) end;
  putoffs(tmp, filepos(fb));
end;


begin
  assign(ft, 'weapons.txt'); reset(ft);
  getclass(@MainClass);
  close(ft);

  assign(fb, 'weapons.cfG'); rewrite(fb, 1);
  long := $50617200; blockwrite(fb, long, 4);
  long := $00000000; blockwrite(fb, long, 4);
  long := $00000008; blockwrite(fb, long, 4);
  long := $11111111; blockwrite(fb, long, 4);

  putclass(@MainClass);
  long := $00000000; blockwrite(fb, long, 4);

  seek(fb, 12); long := FileSize(fb) - 4; blockwrite(fb, long, 4);
  close(fb);
end.
